/*
 * Generated by SpoonMixinClassProcessor.
 * 
 * Author: Lionel Seinturier <Lionel.Seinturier@lifl.fr>
 */
package org.objectweb.fractal.juliak.control.interceptor;

import java.util.HashMap;

import org.objectweb.fractal.api.Component;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.objectweb.fractal.api.control.BindingController;
import org.objectweb.fractal.api.control.ContentController;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.type.ComponentType;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.julia.ComponentInterface;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.julia.Interceptor;
import org.objectweb.fractal.juliak.asm.ClassGenerator;
import org.objectweb.fractal.juliak.asm.InterceptorClassGenerator;
import org.objectweb.fractal.juliak.asm.TreeParserException;
import org.objectweb.fractal.juliak.control.binding.BindingControllerDef;
import org.objectweb.fractal.juliak.control.content.ContentControllerDef;
import org.objectweb.fractal.juliak.factory.InstanceGenerator;

/** 
 * Default implementation of the {@link InterceptorController} control interface.
 * 
 * @author Lionel Seinturier <Lionel.Seinturier@lifl.fr>
 *  
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin
 */
public class InterceptorCompControllerImpl implements Controller , InterceptorController , InterceptorDefAttributes {
    /** 
     * Does nothing.

     * 

     * @param ic information about the component to which this controller object

     *      belongs.

     * @throws InstantiationException if the initialization fails.

     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(InitializationContext ic) throws InstantiationException {
        if ((interceptorClassGenerator) != null) {
            BindingController bc = ((BindingController)(ic.interfaces.get(("//" + (BindingControllerDef.NAME)))));
            String[] itfNames = bc.listFc();
            InitializationContext intic = new InitializationContext();
            intic.interfaces = new HashMap();
            for (int i = 0 ; i < (itfNames.length) ; i++) {
                String itfName = itfNames[i].substring(2);
                Object end = org.objectweb.fractal.juliak.FractalHelper.lookupFc(bc ,itfNames[i]);
                while (end instanceof ComponentInterface) {
                    ComponentInterface ci = ((ComponentInterface)(end));
                    end = ci.getFcItfImpl();
                }
                intic.interfaces.put(itfName ,end);
            }
            Component compctrl = ((Component)(ic.interfaces.get("component")));
            ContentController cc = null;
            try {
                Object o = compctrl.getFcInterface(ContentControllerDef.NAME);
                cc = ((ContentController)(o));
            } catch (NoSuchInterfaceException nsie) {
            }
            ComponentType ct = ((ComponentType)(compctrl.getFcType()));
            InterfaceType[] its = ct.getFcInterfaceTypes();
            for (int i = 0; i < its.length; i++) {
                InterfaceType it = its[i];
                String itfName = it.getFcItfName();
                if (it.isFcCollectionItf()) {
                    itfName = "/juliak/collection/" + (it.getFcItfName());
                } 
                Object itf = org.objectweb.fractal.juliak.FractalHelper.getFcInterface(compctrl ,itfName);
                addFcInterceptor(itf ,intic ,cc);
            }
        } 
        initFcController$0(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#addFcInterceptor(java.lang.Object,org.objectweb.fractal.julia.InitializationContext,org.objectweb.fractal.api.control.ContentController)
     */
    private void addFcInterceptor(Object o, InitializationContext intic, ContentController cc) throws InstantiationException {
        ComponentInterface itf = ((ComponentInterface)(o));
        InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
        String itfName = itf.getFcItfName();
        if (org.objectweb.fractal.juliak.FractalHelper.isFcControllerInterfaceName(itfName)) {
            return ;
        } 
        if (!(interceptorClassGenerator.match(it))) {
            return ;
        } 
        Object content = interceptorInstanceGenerator.generate(it ,intic);
        Interceptor interceptor = ((Interceptor)(content));
        interceptor.initFcController(intic);
        addFcInterceptor(itf ,interceptor);
        if (cc != null) {
            if (it.isFcCollectionItf()) {
                itfName = "/juliak/collection/" + itfName;
            } 
            ComponentInterface intitf = ((ComponentInterface)(org.objectweb.fractal.juliak.FractalHelper.getFcInternalInterface(cc ,itfName)));
            addFcInterceptor(intitf ,interceptor);
        } 
    }
    
    /** 
     * Appends the specified interceptor at the end of the list of already

     * existing interceptors for the specified Fractal interface.

     * 

     * @param itf          the Fractal interface

     * @param interceptor  the interceptor

     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#addFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    public void addFcInterceptor(ComponentInterface itf, Interceptor interceptor) {
        Object last = null;
        Object next = itf.getFcItfImpl();
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            last = next;
            next = i.getFcItfDelegate();
        }
        if (last == null) {
            Object content = itf.getFcItfImpl();
            interceptor.setFcItfDelegate(content);
            itf.setFcItfImpl(interceptor);
        } else {
            Interceptor i = ((Interceptor)(last));
            Object content = i.getFcItfDelegate();
            interceptor.setFcItfDelegate(content);
            i.setFcItfDelegate(interceptor);
        }
        itf.updateFcState();
    }
    
    /** 
     * Returns the array of interceptors associated to the specified Fractal

     * interface.

     * 

     * @param itf  the Fractal interface

     * @return     the array of interceptors

     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#getFcInterceptors(org.objectweb.fractal.julia.ComponentInterface)
     */
    public Interceptor[] getFcInterceptors(ComponentInterface itf) {
        Object next = itf.getFcItfImpl();
        int size = 0;
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            next = i.getFcItfDelegate();
            size++;
        }
        Interceptor[] result = new Interceptor[size];
        next = itf.getFcItfImpl();
        size = 0;
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            result[size] = i;
            next = i.getFcItfDelegate();
            size++;
        }
        return result;
    }
    
    /** 
     * Removes the specified interceptor from the list of already existing

     * interceptors for the specified Fractal interface.

     * 

     * @param itf          the Fractal interface

     * @param interceptor  the interceptor

     * @return             true if the list contained the specified interceptor

     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#removeFcInterceptor(org.objectweb.fractal.julia.ComponentInterface,org.objectweb.fractal.julia.Interceptor)
     */
    public boolean removeFcInterceptor(ComponentInterface itf, Interceptor interceptor) {
        Object previous = null;
        Object next = itf.getFcItfImpl();
        while (next instanceof Interceptor) {
            Interceptor i = ((Interceptor)(next));
            if (next == interceptor) {
                Object nextnext = i.getFcItfDelegate();
                if (previous == null) {
                    itf.setFcItfImpl(nextnext);
                } else {
                    Interceptor p = ((Interceptor)(previous));
                    p.setFcItfDelegate(nextnext);
                }
                itf.updateFcState();
                return true;
            } 
            previous = next;
            next = i.getFcItfDelegate();
        }
        return false;
    }
    
    /** 
     * @param interceptors

     *      A stringified representation of a Julia

     *      {@link org.objectweb.fractal.julia.loader.Tree} structure describing

     *      the interceptor class generators associated with this control

     *      membrane.

     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#setInterceptors(java.lang.String)
     */
    public void setInterceptors(String interceptors) {
        this.interceptors = interceptors;
        try {
            interceptorClassGenerator = new InterceptorClassGenerator(interceptors);
        } catch (TreeParserException e) {
            final String msg = (("Bad interceptor descriptor: " + (e.getMessage())) + "\n") + interceptors;
            throw new RuntimeException(msg);
        }
        interceptorInstanceGenerator = new InstanceGenerator(interceptorClassGenerator);
    }
    
    /** 
     * @return

     *      A stringified representation of a Julia

     *      {@link org.objectweb.fractal.julia.loader.Tree} structure describing

     *      the interceptor class generators associated with this control

     *      membrane.

     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#getInterceptors()
     */
    public String getInterceptors() {
        return interceptors;
    }
    
    /** 
     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#interceptors
     */
    private String interceptors = "";
    
    /** 
     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#interceptorClassGenerator
     */
    private ClassGenerator interceptorClassGenerator;
    
    /** 
     * @see org.objectweb.fractal.juliak.control.interceptor.InterceptorControllerMixin#interceptorInstanceGenerator
     */
    private InstanceGenerator interceptorInstanceGenerator;
    
}